// Written by TeTeT

airboss = player;

[] spawn {
	sleep 0.3;
	private _channelID = radioChannelCreate [[0.96, 0.34, 0.13, 0.8], "Old Salt", "%UNIT_NAME", [player]];

	if (_channelID == 0) then {
		"Custom Radio Channel Creation failed" call bis_fnc_error;
	};

	Nimitz setVariable ["ttt_nimitz_radio", _channelID];
};

[Nimitz] spawn {
	params ["_carrier"];
	sleep 0.5;
	private _parkingEnd = [_carrier, "C2T"] call ttt_amp_kf_fnc_getMemPointNimitz;
	_parkingEnd = _parkingEnd getPos [1, getDir _carrier - 90];
	_parkingEnd set [2, (getPosASL _carrier select 2) + 17.441];
	private _parkingStart = [_carrier, "C2"] call ttt_amp_kf_fnc_getMemPointNimitz;
	_parkingStart = _parkingStart getPos [2, getDir _carrier - 90];
	_parkingStart set [2, (getPosASL _carrier select 2) + 17.441];

	private _parkingPos = _parkingEnd;
	private _parkingPositions = [];
	private _planes = [];
	while {_parkingPos distance _parkingStart > 25} do {
		_parkingPositions pushBack _parkingPos;
		_parkingPos = _parkingPos getPos [-13, getDir _carrier];
		_parkingPos set [2, (getPosASL _carrier select 2) + 17.441];
	};

	// need to initialize point as well later
	private _allParkingPositions = createHashMapFromArray [
		["crotch", _parkingPositions],
		["point", []]
	];
	_carrier setVariable ["ttt_nimitz_parkingPositions", _allParkingPositions];


	private _tractorClass = "Peral_AS32A";
	private _cartClass = "ttt_weaponscart";

	private _spawnPos = [_carrier, "E5Top"] call ttt_amp_kf_fnc_getMemPointNimitz;
	_spawnPos = _spawnPos getPos [10, getDir _carrier + 90];
	_spawnPos set [2, (getPosASL _carrier select 2) + 17.441];
	private _tractorFore = createVehicle [_tractorClass, _spawnPos, [], 0, "NONE"];
	_tractorFore setPosASL _spawnPos;
	_tractorFore setDir (getDir _carrier - 90);
	private _cart = createVehicle [_cartClass, [0,0,1000], [], 0, "NONE"];
	_cart attachTo [_tractorFore, [0.35, -3.4, 0.6]];
	_cart setDir -180;
	[_carrier, _cart, 0] spawn ttt_amp_kf_fnc_unloadCart;
	_tractorFore setVariable ["ttt_amp_startPos", getPosASL _tractorFore];
	createVehicleCrew _tractorFore;


	private _spawnPos = [_carrier, "E2"] call ttt_amp_kf_fnc_getMemPointNimitz;
	_spawnPos = _spawnPos getPos [-14, getDir _carrier];
	_spawnPos set [2, (getPosASL _carrier select 2) + 17.441];
	private _tractorCenter = createVehicle [_tractorClass, _spawnPos, [], 0, "NONE"];
	_tractorCenter setPosASL _spawnPos;
	_tractorCenter setDir (getDir _carrier - 90);
	private _cart = createVehicle [_cartClass, [0,0,1000], [], 0, "NONE"];
	_cart attachTo [_tractorCenter, [0.35, -3.4, 0.6]];
	_cart setDir -180;
	[_carrier, _cart, 0] spawn ttt_amp_kf_fnc_unloadCart;
	_tractorCenter setVariable ["ttt_amp_startPos", getPosASL _tractorCenter];
	createVehicleCrew _tractorCenter;

	private _tractors = createHashMapFromArray [
		["foreParking", _tractorFore],
		["centerParking", _tractorCenter]
		//,
		// ["aftParking", _tractorAft]
	];

	_carrier setVariable ["ttt_nimitz_tractors", _tractors];
};

[Nimitz, "JS_JC_FA18E"] spawn {
	params ["_carrier", "_planeClass"];
	[_carrier] call ttt_amp_kf_fnc_landEventsInit;
	while {alive player} do {
		sleep 1;
		systemChat "New landing cycle";
		private _plane = [_carrier, _planeClass] call ttt_fnc_spawnAndLand;
		waitUntil {sleep 5; not isEngineOn _plane};
	};
};


ttt_fnc_spawnAndLand = {
	params ["_carrier", "_planeClass"];

	private _spawnPos = _carrier getPos [6000, getDir _carrier + 170];
	_spawnPos set [2, 500];
	private _plane = createVehicle [_planeClass, _spawnPos, [], 0, "FLY"];
	createVehicleCrew _plane;
	_plane setDir (getDir _carrier);
	_plane setVelocityModelSpace [0, 100, 0];

	[_carrier, "ttt_nimitz_planeRequestLand", [_carrier, _plane], false] 
		call BIS_fnc_callScriptedEventHandler;
	_plane;
};

ttt_amp_kf_fnc_landEventsInit = {
	params ["_nimitz"];

	[_nimitz, "ttt_nimitz_planeRequestLand", ttt_amp_kf_fnc_requestLand] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_planeApproaching", ttt_amp_kf_fnc_approach] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_planeLanded", ttt_amp_kf_fnc_landed] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_planeLanded", ttt_amp_kf_fnc_prepPlaneForTaxi] call BIS_fnc_addScriptedEventHandler;
	// [_nimitz, "ttt_nimitz_planeLanded", ttt_fnc_thisScriptTest] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_planeRequestParking", ttt_amp_kf_fnc_requestParking] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_planeTaxiToCrossroads", ttt_amp_kf_fnc_taxiToCrossroads] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_planeTaxiToParkingPrep", ttt_amp_kf_fnc_taxiToPP] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_planeTaxiToParking", ttt_amp_kf_fnc_taxiToParking] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_planeTaxiToParking", ttt_amp_kf_fnc_tractorToCrotch] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_tractorToParkingDisarm", ttt_amp_kf_fnc_tractorToParkingDisarm] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_tractorDisarm", ttt_amp_kf_fnc_tractorDisarm] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_tractorToWeapons", ttt_amp_kf_fnc_tractorToWeapons] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_tractorToWeapons", ttt_amp_kf_fnc_raiseWeaponsElevator] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_tractorAtWeapons", ttt_amp_kf_fnc_tractorAtWeapons] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_tractorReturn", ttt_amp_kf_fnc_tractorReturn] call BIS_fnc_addScriptedEventHandler;
	[_nimitz, "ttt_nimitz_tractorReturn", ttt_amp_kf_fnc_lowerWeaponsElevator] call BIS_fnc_addScriptedEventHandler;
	_nimitz;
};


ttt_amp_kf_fnc_requestLand = {
	params ["_carrier", "_plane"];
	private _radio = _carrier getVariable "ttt_nimitz_radio";

	if ([_carrier, "jdg_landingDeck"] call ttt_amp_kf_fnc_getDeckStatus == "C") then {
		airboss customChat [_radio, "Deck status clear, plane approaching!"];
		_plane landAt (_carrier getVariable "JDG_dynamicAirportNimitz");

		_plane addEventHandler ["Gear", {
			params ["_vehicle", "_gearState"];
			private _nimitzArr = _vehicle nearEntities ["jdg_carrier_spawner", 2000];
			if (count _nimitzArr > 1) then {
				"More than one Nimitz found, choosing random one" call bis_fnc_error;
			};
			if (_gearState and count _nimitzArr > 0 and not(isPlayer driver _vehicle)) then {
				private _carrier = _nimitzArr select 0;
				[_carrier, "ttt_nimitz_planeApproaching", [_carrier, _vehicle], false] 
					call BIS_fnc_callScriptedEventHandler;
			};
		}];
	} else {
		airboss customChat [_radio, "Deck status foul, no permission to land"];
		sleep 30;
		// not sure if this is smart as an endless loop, most likely not
		[_carrier, _plane] call ttt_amp_kf_fnc_requestLand;
	};
};

ttt_amp_kf_fnc_approach = {
	params ["_carrier", "_plane"];
	private _radio = _carrier getVariable "ttt_nimitz_radio";

	airboss customChat [_radio, "Plane on final approach"];
	[_plane] call ttt_amp_kf_fnc_tailhookDown;
	[_plane, _carrier, false] call ttt_amp_kf_fnc_glidePath;	

	_plane addEventHandler ["LandedStopped", {
		params ["_plane", "_airportID", "_airportObject"];

		if (not isPlayer driver _plane) then {
			[_airportObject getVariable "TTT_NimitzParent", "ttt_nimitz_planeLanded", [_airportObject getVariable "TTT_NimitzParent", _plane], false]
				call BIS_fnc_callScriptedEventHandler;
		};
	}];
};

ttt_amp_kf_fnc_landed = {
	params ["_carrier", "_plane"];
	private _radio = _carrier getVariable "ttt_nimitz_radio";
	
	airboss customChat [_radio, "Welcome aboard"];
	_plane setVelocityModelSpace [0,0,0];

	[_carrier, _plane] spawn {
		params ["_carrier", "_plane"];
		_carrier setVariable ["ttt_nimitz_planeLanded_stop", []];
		sleep 1;

		waitUntil {
			sleep 1; 
			systemChat "Waiting on scripts to complete"; 
			count (_carrier getVariable ["ttt_nimitz_planeLanded_stop", []]) == 0
		};

		[_carrier, "ttt_nimitz_planeRequestParking", [_carrier, _plane]]
			call BIS_fnc_callScriptedEventHandler;
		_carrier setVariable ["ttt_nimitz_planeLanded_stop", nil];
	};
};

ttt_amp_kf_fnc_requestParking = {
	params ["_carrier", "_plane"];
	private _radio = _carrier getVariable "ttt_nimitz_radio";

	airboss customChat [_radio, "Checking for parking spot"];
	private _parkingPos = [];
	private _parkingArea = "";
	{
		airboss customChat [_radio, format ["Checking %1", _x]];
		private _possibleParkingPos = [
			_y, 
			[_plane], 
			{_input0 distance _x}, 
			"DESCEND", 
			{[_carrier, _x] call ttt_amp_kf_fnc_parkingFree}
		] call BIS_fnc_sortBy;
		if (count _possibleParkingPos > 0) then {
			_parkingPos = _possibleParkingPos select 0;
			_parkingArea = _x;
		} else {
			airboss customChat [_radio, "No free spot here"];
		};
	} forEach (_carrier getVariable "ttt_nimitz_parkingPositions");
	if (count _parkingPos > 0) then {
		airboss customChat [_radio, format ["Parking plane at %1", _parkingArea]];
		_plane setVariable ["ttt_nimitz_parkingInfo", [_parkingArea, _parkingPos]];

		if ([_carrier, _plane, "C1"] call ttt_amp_kf_fnc_checkPlaneToMempoint == "C" and 
			isNull (_carrier getVariable ["ttt_nimitz_tractorAtFore", objNull])) then {
			_plane setVariable ["ttt_nimitz_taxiAttemptToCrossroads", nil];
			[_carrier, "ttt_nimitz_planeTaxiToCrossroads", [_carrier, _plane]]
				call BIS_fnc_callScriptedEventHandler;
		} else {
			airboss customChat [_radio, "Taxi to crossroads blocked"];
			airboss customChat [_radio, "Trying again in 10 seconds ..."];
			private _attempts = (_plane getVariable ["ttt_nimitz_taxiAttemptToCrossroads", 0]) + 1;
			
			if (_attempts == 20) then {
				airboss customChat [_radio, "Giving up taxiing, despawning plane on the spot"];
				deleteVehicleCrew _plane;
				deleteVehicle _plane;
			} else {
				_plane setVariable ["ttt_nimitz_taxiAttemptToCrossroads", _attempts];
				[_carrier, _plane] spawn {
					sleep 10;
					_this call ttt_amp_kf_fnc_requestParking;
				};
			};
		};
	} else {
		airboss customChat [_radio, "No free parking"];
		airboss customChat [_radio, "Giving up parking, despawning plane on the spot"];
		// Maybe we should go to an elevator instead?
		deleteVehicleCrew _plane;
		deleteVehicle _plane;
	};
};

ttt_amp_kf_fnc_parkingFree = {
	params ["_carrier", "_pos", ["_excludeList", ["jdg_wire_center", "jdg_carrier_spawner", "jdg_fuel"]]];
	private _planeSize = 6; // wingspan roughly, wings folded

	private _poly = [
		_pos getPos [_planeSize, getDir _carrier + 120],
		_pos getPos [_planeSize, getDir _carrier + 210],
		_pos getPos [_planeSize, getDir _carrier + 300],
		_pos getPos [_planeSize, getDir _carrier + 30]
	];

	private _ret = true;

	{
		if ( (getPosASL _x) # 2 - (getPosASL _carrier) # 2 < 20 and 
			getPosASL _x inPolygon _poly and 
			not (toLower typeOf _x in _excludeList) ) then {
				systemChat format ["%3 - In the way: %1", _x, typeOf _x];
				_ret = false;
		};
	// probably want to cache that nearEntities call
	} forEach (_carrier nearEntities [["Air", "Land", "Ship"], 200]);
	_ret;
};

ttt_amp_kf_fnc_taxiPlane = {
	params ["_carrier", "_plane", "_vehicle", "_pos", "_dir", "_callback", ["_speed", 3.6]];

	private _time = (_vehicle distance _pos) / _speed; // 10 km/h by default, 3.6 m/s
	private _keysData = [
		// Tried to turn the plane around, didn't look nice
		[	
			0,
			getPosASL _vehicle,
			[
				vectorDir _vehicle,
				[0,0,1]
			],
			[
				["Time", 0],
				["LeaveTangent", vectorDir _vehicle],
				["LeaveTangentWeight", 100],
				["InterpMode", 1]
			]
		],
		[
			1,
			_pos,
			[
				_dir,
				[0,0,1]
			],
			[
				["Time", _time],
				["ArriveTangent", _dir vectorMultiply -1],
				["ArriveTangentWeight", 100],
				["InterpMode", 1]
			]
		]
	];

	private _timelineData     = [ // Timeline variables
	    ["Length", _time],
	    ["Loop", false],
		["InterpMode", 1],
		["EventFinished", _callback]
	];

	private _curvesData = [
	    [ // curve1
	    	[_vehicle], // vehicles
	        [ // Curve variables
	            ["OrientationMode", 3],
	            ["TimeInSeconds", true]
	        ],
	        _keysData
	    ]
	];

	private _group = [_carrier] call ttt_amp_kf_fnc_getGroup;

	private _timeline = [_timelineData, _curvesData, _group] call ttt_amp_kf_fnc_keyframe;
	_timeline setVariable ["ttt_amp_carrier", _carrier];
	_timeline setVariable ["ttt_amp_plane", _plane];
	[_timeline] call BIS_fnc_timeline_play;
	_vehicle animateSource ["wheel_rot_source", 1e12];
	_timeline
};


ttt_amp_kf_fnc_taxiToCrossroads = {
	params ["_carrier", "_plane"];
	private _radio = _carrier getVariable "ttt_nimitz_radio";

	private _crossRoads = [_carrier, "C1"] call ttt_amp_kf_fnc_getMemPointNimitz;
	_crossRoads = _crossRoads getPos [7, (getDir _carrier) - 90];
	_crossRoads set [2, (getPosASL _carrier select 2) + 17.441];

	[_carrier, _plane, _plane, _crossRoads, vectorDir _carrier, "_this call ttt_amp_kf_fnc_atCrossroads"] call ttt_amp_kf_fnc_taxiPlane;
	// _plane setPosASL _crossRoads;
	// _plane setDir (getDir _carrier);
	_carrier;
};


ttt_amp_kf_fnc_atCrossroads = {
	params ["_timeline"];

	private _carrier = _timeline getVariable "ttt_amp_carrier";
	private _plane = _timeline getVariable "ttt_amp_plane";
	private _radio = _carrier getVariable "ttt_nimitz_radio";

	airboss customChat [_radio, "At crossroads"];

	if ([_carrier, _plane, "C1T"] call ttt_amp_kf_fnc_checkPlaneToMempoint == "C") then {	
		_plane setVariable ["ttt_nimitz_taxiAttemptToParkingPrep", nil];		
		[_carrier, "ttt_nimitz_planeTaxiToParkingPrep", [_carrier, _plane]]
			call BIS_fnc_callScriptedEventHandler;
	} else {
		airboss customChat [_radio, "Taxi to parking prep blocked"];
		airboss customChat [_radio, "Trying again in 10 seconds ..."];
		private _attempts = (_plane getVariable ["ttt_nimitz_taxiAttemptToParkingPrep", 0]) + 1;
		
		if (_attempts == 5) then {
			airboss customChat [_radio, "Giving up taxiing, despawning plane on the spot"];
			deleteVehicleCrew _plane;
			deleteVehicle _plane;
		} else {
			_plane setVariable ["ttt_nimitz_taxiAttemptToParkingPrep", _attempts];
			[_carrier, _plane] spawn {
				sleep 10;
				_this call ttt_amp_kf_fnc_taxiToCrossroads;
			};
		};
	};
	_carrier;
};

ttt_amp_kf_fnc_checkPlaneToMempoint = {
	params ["_carrier", "_plane", "_memPointName", ["_excludeList", ["jdg_wire_center", "jdg_carrier_spawner", "jdg_fuel"]]];

	private _memPoint = [_carrier, _memPointName] call ttt_amp_kf_fnc_getMempointNimitz;
	[_carrier, _plane, _memPoint] call ttt_amp_kf_fnc_checkPlaneToPoint;
};

ttt_amp_kf_fnc_checkPlaneToPoint = {
	params ["_carrier", "_plane", "_point", ["_excludeList", ["jdg_wire_center", "jdg_carrier_spawner", "jdg_fuel"]]];

	private _planeSize = 6;

	private _poly = [
		_plane getPos [_planeSize, (_plane getDir _point) + 90],
		_plane getPos [_planeSize, (_plane getDir _point) - 90],
		_point getPos [_planeSize, (_plane getDir _point) - 90],
		_point getPos [_planeSize, (_plane getDir _point) + 90]
	];

	private _ret = "C";
	{
		if ( (getPosASL _x) # 2 - (getPosASL _carrier) # 2 < 20 and 
			getPosASL _x inPolygon _poly and 
			not (toLower typeOf _x in _excludeList) and 
			_x != _plane ) then {
				// systemChat format ["%3 - In the way: %1 (%2)", _x, typeOf _x, _elevator];
				_ret = "F";
		};
	} forEach (_plane nearEntities [["Air", "Land", "Ship"], _plane distance _point]);

	_ret;
};

ttt_amp_kf_fnc_taxiToPP = {
	params ["_carrier", "_plane"];
	private _radio = _carrier getVariable "ttt_nimitz_radio";

	_plane getVariable "ttt_nimitz_parkingInfo" params ["_area", "_pp"];
	// private _dir = [vectorDir _carrier select 1, (vectorDir _carrier select 0) * -1, 0];
	// if (_area == "crotch") then {
	// 	_dir = _dir vectorMultiply -1;
	// };

	private _d = getDir _carrier + 90;
	if (_area == "crotch") then {
		_d = getDir _carrier - 90;
	};

	private _ppPrep = _pp getPos [15, _d + 180];
	_ppPrep set [2, (getPosASL _carrier select 2) + 17.441];

	[_carrier, _plane, _plane, _ppPrep, vectorDir _carrier, "_this call ttt_amp_kf_fnc_atParkingPrep"] call ttt_amp_kf_fnc_taxiPlane;
	// _plane setPosASL _ppPrep;
	// _plane setDir _dir;
	_carrier;
};

ttt_amp_kf_fnc_atParkingPrep = {
	params ["_timeline"];

	private _carrier = _timeline getVariable "ttt_amp_carrier";
	private _plane = _timeline getVariable "ttt_amp_plane";
	private _radio = _carrier getVariable "ttt_nimitz_radio";
	_plane getVariable "ttt_nimitz_parkingInfo" params ["_area", "_pp"];

	airboss customChat [_radio, "At parking prep"];
	if ([_carrier, _plane, _pp] call ttt_amp_kf_fnc_checkPlaneToPoint == "C") then {
		_plane setVariable ["ttt_nimitz_taxiAttemptToParking", nil];
		[_carrier, "ttt_nimitz_planeTaxiToParking", [_carrier, _plane]]
			call BIS_fnc_callScriptedEventHandler;
	} else {
		airboss customChat [_radio, "Taxi to parking blocked"];
		airboss customChat [_radio, "Trying again in 10 seconds ..."];
		private _attempts = (_plane getVariable ["ttt_nimitz_taxiAttemptToParking", 0]) + 1;
		
		if (_attempts == 5) then {
			airboss customChat [_radio, "Giving up taxiing, despawning plane on the spot"];
			deleteVehicleCrew _plane;
			deleteVehicle _plane;
		} else {
			_plane setVariable ["ttt_nimitz_taxiAttemptToParking", _attempts];
			[_carrier, _plane] spawn {
				sleep 10;
				_this call ttt_amp_kf_fnc_taxiToPP;
			};
		};
	};

	_carrier;
};

ttt_amp_kf_fnc_taxiToParking = {
	params ["_carrier", "_plane"];
	private _radio = _carrier getVariable "ttt_nimitz_radio";

	airboss customChat [_radio, "Parking plane"];

	_this spawn {
		params ["_carrier", "_plane"];
		_plane getVariable "ttt_nimitz_parkingInfo" params ["_area", "_pp"];

		// private _dir = getDir _carrier - 90;
		// if (_area == "crotch") then {
		// 	_dir = getDir _carrier + 120;
		// };
		_plane animateSource ["wheel_rot_source", 0, true];
		_plane animateSource ["wheel_rot_source", -1e12];
		while { abs((_plane getRelDir _carrier) - 90) > 1} do {
			_plane setDir (getDir _plane + 0.3);
			sleep 0.05;
		};
		_plane setDir (getDir _carrier + 90);

		private _keysData = [
			[	
				0,
				getPosASL _plane,
				[
					(vectorDir _plane) vectorMultiply -1,
					[0,0,1]
				],
				[
					["Time", 0],
					["LeaveTangent", (vectorDir _plane) vectorMultiply -1],
					["LeaveTangentWeight", 100],
					["InterpMode", 0]
				]
			],
			[
				1,
				_pp,
				[
					vectorDir _plane,
					[0,0,1]
				],
				[
					["Time", 20],
					["ArriveTangent", vectorDir _plane],
					["ArriveTangentWeight", 0],
					["InterpMode", 0]
				]
			]
		];

		private _timelineData     = [ // Timeline variables
		    ["Length", 20],
		    ["Loop", false],
			["InterpMode", 0],
			["EventFinished", "_this call ttt_amp_kf_fnc_parkFinal"]
		];

		private _curvesData = [
		    [ // curve1
		    	[_plane], // vehicles
		        [ // Curve variables
		            ["OrientationMode", 0],
		            ["TimeInSeconds", true]
		        ],
		        _keysData
		    ]
		];

		private _group = [_carrier] call ttt_amp_kf_fnc_getGroup;

		_timeline = [_timelineData, _curvesData, _group] call ttt_amp_kf_fnc_keyframe;
		_timeline setVariable ["ttt_amp_carrier", _carrier];
		_timeline setVariable ["ttt_amp_parkingPlane", _plane];
		_timeline setVariable ["ttt_amp_parkingPos", _pp];
		[_timeline] call BIS_fnc_timeline_play;

	};
	// _plane setPosASL _pp;
	// _plane setDir _dir;
	_carrier;
};

ttt_amp_kf_fnc_parkFinal = {
	params ["_timeline"];
	private _carrier = _timeline getVariable "ttt_amp_carrier";
	private _plane = _timeline getVariable "ttt_amp_parkingPlane";

	[_plane, _carrier] spawn {
		params ["_plane", "_carrier"];

		// needs to be more elegant
		while { abs((_plane getRelDir _carrier) - 60) > 1} do {
			_plane setDir (getDir _plane + 0.3);
			sleep 0.05;
		};
		_plane setDir (getDir _carrier + 120);
		_plane engineOn false;
		_plane animateSource ["wheel_rot_source", 0, true];
		// TODO: force to get out and despawn
		deleteVehicleCrew _plane;
	};
	_carrier;
};

ttt_amp_kf_fnc_prepPlaneForTaxi = {
	_this spawn {
		params ["_carrier", "_plane"];
		// no accidential taxiing over board!
		(driver _plane) setDamage 1;
		(_carrier getVariable "ttt_nimitz_planeLanded_stop") pushBack "ttt_amp_kf_fnc_prepPlaneForTaxi";
		private _radio = _carrier getVariable "ttt_nimitz_radio";
		[_plane, 1] call ttt_amp_kf_fnc_f18_wingfold;
		[_plane] call ttt_amp_kf_fnc_tailhookUp;	
		sleep 5;
		(_carrier getVariable "ttt_nimitz_planeLanded_stop") deleteAt
			((_carrier getVariable "ttt_nimitz_planeLanded_stop") find "ttt_amp_kf_fnc_prepPlaneForTaxi");
	};
};

// ttt_fnc_thisScriptTest = {
// 	_this spawn {
// 		params ["_carrier", "_plane"];
// 		systemChat format ["ScriptHandle: %1", _thisScript];
// 	};
// };

ttt_amp_kf_fnc_assignTractor = {
	params ["_carrier", "_area"];

	// how to track which tractor does what, one tractor per area for now
	private _tractor = _carrier getVariable "ttt_nimitz_tractors" get _area;
	if (isNull (_tractor getVariable ["ttt_nimitz_plane", objNull])) then {
		_tractor;
	} else {
		objNull;
	};
};

ttt_amp_kf_fnc_tractorToCrotch = {
	params ["_carrier", "_plane"];
	private _radio = _carrier getVariable "ttt_nimitz_radio";

	private _tractor = [_carrier, "foreParking"] call ttt_amp_kf_fnc_assignTractor;

	if (not isNull _tractor) then {
		airboss customChat [_radio, "Calling tractor to crotch"];
		_plane setVariable ["ttt_nimitz_tractor", _tractor];
		_tractor setVariable ["ttt_nimitz_plane", _plane];
		if ([_carrier, _tractor, "C2"] call ttt_amp_kf_fnc_checkPlaneToMempoint == "C") then {
			private _toCrotch = [_carrier, "C2"] call ttt_amp_kf_fnc_getMemPointNimitz;
			_toCrotch = _toCrotch getPos [5, getDir _carrier + 90];
			_toCrotch set [2, (getPosASL _carrier select 2) + 17.441];
			
			_tractor setVariable ["ttt_nimitz_tractorAttemptToCrotch", nil];
			_tractor engineOn true;

			[_carrier, _plane, _tractor, _toCrotch, vectorDir _carrier, "_this call ttt_amp_kf_fnc_tractorAtCrotch", 2] call ttt_amp_kf_fnc_taxiPlane;
			private _cart = (attachedObjects _tractor) select 0;
			_cart animateSource ["wheel_rot_source", 1e12];
		} else {
			airboss customChat [_radio, "Tractor to crotch approach blocked"];
			airboss customChat [_radio, "Trying again in 10 seconds ..."];
			private _attempts = (_tractor getVariable ["ttt_nimitz_tractorAttemptToCrotch", 0]) + 1;
			
			if (_attempts == 5) then {
				airboss customChat [_radio, "Giving up driving to crotch, despawning tractor on the spot"];
				deleteVehicle (attachedObjects _tractor select 0);
				deleteVehicleCrew _tractor;
				deleteVehicle _tractor;
			} else {
				_tractor setVariable ["ttt_nimitz_tractorAttemptToCrotch", _attempts];
				[_carrier, _plane] spawn {
					sleep 10;
					_this call ttt_amp_kf_fnc_tractorToCrotch;
				};
			};
		};
	} else {
		// TODO introduce the attempts mode, this is running endlessly
		airboss customChat [_radio, "No tractor for fore parking available"];
		airboss customChat [_radio, "Trying in 30 seconds again"];
		_this spawn {
			sleep 30;
			_this call ttt_amp_kf_fnc_tractorToCrotch;
		};
	};
};

ttt_amp_kf_fnc_tractorAtCrotch = {
	params ["_timeline"];
	private _carrier = _timeline getVariable "ttt_amp_carrier";
	private _plane = _timeline getVariable "ttt_amp_plane";
	private _radio = _carrier getVariable "ttt_nimitz_radio";

	airboss customChat [_radio, "Tractor at crotch"];
	[_carrier, "ttt_nimitz_tractorToParkingDisarm", [_carrier, _plane]]
		call BIS_fnc_callScriptedEventHandler;
};

ttt_amp_kf_fnc_tractorToParkingDisarm = {
	params ["_carrier", "_plane"];
	private _radio = _carrier getVariable "ttt_nimitz_radio";
	private _tractor = _plane getVariable "ttt_nimitz_tractor";

// _plane setVariable ["ttt_nimitz_parkingInfo", [_parkingArea, _parkingPos]];
	private _parkingPos = (_plane getVariable "ttt_nimitz_parkingInfo") select 1;

	private _disarmPoint = _parkingPos getPos [10, getDir _carrier + 90];
	_disarmPoint set [2, (getPosASL _carrier select 2) + 17.441];

	if ([_carrier, _tractor, _disarmPoint] call ttt_amp_kf_fnc_checkPlaneToPoint == "C") then {
		airboss customChat [_radio, "Tractor driving to disarm point"];

		_tractor setVariable ["ttt_nimitz_tractorAttemptToDisarm", nil];
		_carrier setVariable ["ttt_nimitz_tractorAtFore", _tractor];
		[_carrier, _plane, _tractor, _disarmPoint, vectorDir _carrier, "_this call ttt_amp_kf_fnc_tractorAtDisarm", 2] call ttt_amp_kf_fnc_taxiPlane;

		// _tractor setPosASL _disarmPoint;
		// _tractor setDir (getDir _carrier);
	} else {
		airboss customChat [_radio, "Tractor to disarm blocked"];
		airboss customChat [_radio, "Trying again in 10 seconds ..."];
		private _attempts = (_tractor getVariable ["ttt_nimitz_tractorAttemptToDisarm", 0]) + 1;
		
		if (_attempts == 5) then {
			airboss customChat [_radio, "Giving up driving to disarm, despawning tractor on the spot"];
			deleteVehicle (attachedObjects _tractor select 0);
			deleteVehicleCrew _tractor;
			deleteVehicle _tractor;
		} else {
			_tractor setVariable ["ttt_nimitz_tractorAttemptToDisarm", _attempts];
			[_carrier, _plane] spawn {
				sleep 10;
				_this call ttt_amp_kf_fnc_tractorToParkingDisarm;
			};
		};
	};
};

ttt_amp_kf_fnc_tractorAtDisarm = {
	params ["_timeline"];
	private _carrier = _timeline getVariable "ttt_amp_carrier";
	private _plane = _timeline getVariable "ttt_amp_plane";
	private _radio = _carrier getVariable "ttt_nimitz_radio";
	airboss customChat [_radio, "Tractor at disarm point"];
	[_carrier, "ttt_nimitz_tractorDisarm", [_carrier, _plane]]
		call BIS_fnc_callScriptedEventHandler;
};

ttt_amp_kf_fnc_tractorDisarm = {
	params ["_carrier", "_plane"];
	private _radio = _carrier getVariable "ttt_nimitz_radio";
	private _tractor = _plane getVariable "ttt_nimitz_tractor";
	private _cart = (attachedObjects _tractor) select 0;
	private _parkingPos = (_plane getVariable "ttt_nimitz_parkingInfo") select 1;
	
	_tractor animateSource ["wheel_rot_source", 0, true];
	_cart animateSource ["wheel_rot_source", 0, true];

	private _planeArr = _parkingPos nearEntities [["Air"], 5];
	if (count _planeArr != 1) exitWith {
		"None or too many planes found" call bis_fnc_error;

		[_carrier, "ttt_nimitz_tractorToWeapons", [_carrier, _plane]]
			call BIS_fnc_callScriptedEventHandler;
	};
	private _plane = _planeArr select 0;

	_plane engineOn false;
	_carrier setVariable ["ttt_nimitz_tractorDisarm_stop", []];
	[_carrier, _cart, 1.5] spawn ttt_amp_kf_fnc_loadCart;
	[_carrier, _plane, 1] spawn ttt_amp_kf_fnc_clearPlane;

	[_carrier, _plane] spawn {
		params ["_carrier", "_plane"];
		sleep 1;

		waitUntil {
			sleep 1; 
			systemChat "Waiting on scripts to complete"; 
			count (_carrier getVariable ["ttt_nimitz_tractorDisarm_stop", []]) == 0
		};
		systemChat "Initiating move to weapons elevator";
		[_carrier, "ttt_nimitz_tractorToWeapons", [_carrier, _plane]]
			call BIS_fnc_callScriptedEventHandler;
		_carrier setVariable ["ttt_nimitz_tractorDisarm_stop", nil];
	};
};

ttt_amp_kf_fnc_loadCart = {
	params ["_carrier", "_cart", ["_delay", 5]];
	(_carrier getVariable "ttt_nimitz_tractorDisarm_stop") pushBack "ttt_amp_kf_fnc_loadCart";
	{
		_cart animateSource [_x , 0];
		sleep _delay;
	} forEach [ "m2", "m3", "m1", "m4", "m5", "m7", "m6", "m8"];
	(_carrier getVariable "ttt_nimitz_tractorDisarm_stop") deleteAt
		((_carrier getVariable "ttt_nimitz_tractorDisarm_stop") find "ttt_amp_kf_fnc_loadCart");
 
	_cart;	
};

ttt_amp_kf_fnc_unloadCart = {
	params ["_carrier", "_cart", ["_delay", 5]];
	(_carrier getVariable "ttt_nimitz_tractorAtWeapons_stop") pushBack "ttt_amp_kf_fnc_unloadCart";
	{
		_cart animateSource [_x , 1];
		sleep _delay;
	} forEach [ "m8", "m6", "m7", "m5", "m4", "m1", "m2", "m3"];
	(_carrier getVariable "ttt_nimitz_tractorAtWeapons_stop") deleteAt
		((_carrier getVariable "ttt_nimitz_tractorAtWeapons_stop") find "ttt_amp_kf_fnc_unloadCart");

	_cart;
};

ttt_amp_kf_fnc_clearPlane = {
	params ["_carrier", "_plane", ["_delay", 1]];
	(_carrier getVariable "ttt_nimitz_tractorDisarm_stop") pushBack "ttt_amp_kf_fnc_clearPlane";
	{
		_plane setPylonLoadOut [_x, "", true];
		sleep _delay;
		// hard coded for F/A-18
	} forEach ["pylon1", "pylon2", "pylon3", "pylon4", "pylon5", "pylon6", "pylon7", "pylon8", "pylon9", "pylon10", "pylon11"];
	(_carrier getVariable "ttt_nimitz_tractorDisarm_stop") deleteAt
		((_carrier getVariable "ttt_nimitz_tractorDisarm_stop") find "ttt_amp_kf_fnc_clearPlane");

	_plane;
};

ttt_amp_kf_fnc_tractorToWeapons = {
	params ["_carrier", "_plane"];
	private _radio = _carrier getVariable "ttt_nimitz_radio";
	private _tractor = _plane getVariable "ttt_nimitz_tractor";
	private _cart = attachedObjects _tractor select 0;

	private _weaponsElevator = [_carrier, "E5Top"] call ttt_amp_kf_fnc_getMemPointNimitz;
	private _weapEleUnload = _weaponsElevator getPos [8, getDir _carrier + 90];
	_weapEleUnload set [2, (getPosASL _carrier select 2) + 17.441];

	if ([_carrier, _tractor, _weapEleUnload] call ttt_amp_kf_fnc_checkPlaneToPoint == "C") then {
		airboss customChat [_radio, "Tractor back to weapons elevator"];

		_tractor setVariable ["ttt_nimitz_tractorAttemptToWeapons", nil];
		_tractor animateSource ["wheel_rot_source", 1e12];
		_cart animateSource ["wheel_rot_source", 1e12];
		while {abs(getDir _tractor - (getDir _carrier - 180)) > 1} do {
			_tractor setDir (getDir _tractor + 0.3);
			sleep 0.05;
		};

		[_carrier, _plane, _tractor, _weapEleUnload, (vectorDir _carrier) vectorMultiply -1, "_this call ttt_amp_kf_fnc_tractorWeapons", 3] call ttt_amp_kf_fnc_taxiPlane;

	} else {
		airboss customChat [_radio, "Tractor to weapons elevator blocked"];
		airboss customChat [_radio, "Trying again in 10 seconds ..."];
		private _attempts = (_tractor getVariable ["ttt_nimitz_tractorAttemptToWeapons", 0]) + 1;
		
		if (_attempts == 12) then {
			airboss customChat [_radio, "Giving up driving to weapons elevator, despawning tractor on the spot"];
			deleteVehicleCrew _tractor;
			deleteVehicle _tractor;
			deleteVehicle _cart;
		} else {
			_tractor setVariable ["ttt_nimitz_tractorAttemptToWeapons", _attempts];
			[_carrier, _plane] spawn {
				sleep 10;
				_this call ttt_amp_kf_fnc_tractorToWeapons;
			};
		};
	};
};

ttt_amp_kf_fnc_tractorWeapons = {
	params ["_timeline"];
	private _carrier = _timeline getVariable "ttt_amp_carrier";
	private _plane = _timeline getVariable "ttt_amp_plane";
	private _radio = _carrier getVariable "ttt_nimitz_radio";
	airboss customChat [_radio, "Tractor at weapons elevator"];
	[_carrier, "ttt_nimitz_tractorAtWeapons", [_carrier, _plane]]
		call BIS_fnc_callScriptedEventHandler;
	_carrier;
};

ttt_amp_kf_fnc_tractorAtWeapons = {
	params ["_carrier", "_plane"];
	private _radio = _carrier getVariable "ttt_nimitz_radio";
	private _tractor = _plane getVariable "ttt_nimitz_tractor";
	private _cart = attachedObjects _tractor select 0;

	_carrier setVariable ["ttt_nimitz_tractorAtFore", objNull];
	_tractor animateSource ["wheel_rot_source", 0, true];
	_cart animateSource ["wheel_rot_source", 0, true];

	_carrier setVariable ["ttt_nimitz_tractorAtWeapons_stop", []];
	airboss customChat [_radio, "Unloading tractor"];
	[_carrier, _cart, 1] spawn ttt_amp_kf_fnc_unloadCart;
	[_carrier, _plane] spawn {
		params ["_carrier", "_plane"];
		sleep 1;

		waitUntil {
			sleep 1; 
			systemChat "Waiting on scripts to complete"; 
			count (_carrier getVariable ["ttt_nimitz_tractorAtWeapons_stop", []]) == 0
		};

		[_carrier, "ttt_nimitz_tractorReturn", [_carrier, _plane]]
			call BIS_fnc_callScriptedEventHandler;
		_carrier setVariable ["ttt_nimitz_tractorAtWeapons_stop", nil];
	};
};

ttt_amp_kf_fnc_tractorReturn = {
	params ["_carrier", "_plane"];
	private _radio = _carrier getVariable "ttt_nimitz_radio";
	private _tractor = _plane getVariable "ttt_nimitz_tractor";
	private _cart = attachedObjects _tractor select 0;

	private _startPos = _tractor getVariable "ttt_amp_startPos";

	if ([_carrier, _tractor, _startPos] call ttt_amp_kf_fnc_checkPlaneToPoint == "C") then {
		airboss customChat [_radio, "Tractor returning to start position"];
		_tractor setVariable ["ttt_nimitz_tractorAttemptToStart", nil];
		// systemChat format ["Tractor Pos Start: %1", _startPos];
		// _tractor setPosASL _startPos;
		// _tractor setDir (getDir _carrier - 90);

		_tractor animateSource ["wheel_rot_source", -1e12];
		_cart animateSource ["wheel_rot_source", -1e12];

		while {abs(getDir _tractor - (getDir _carrier -90)) > 1} do {
			_tractor setDir (getDir _tractor + 0.3);
			sleep 0.05;
		};
		private _time_1 = _tractor distance _startPos;
		private _keysData = [
			[	
				0,
				getPosASL _tractor,
				[
					vectorDir _tractor,
					[0,0,1]
				],
				[
					["Time", 0],
					["LeaveTangent", (vectorDir _tractor) vectorMultiply -1],
					["LeaveTangentWeight", 100],
					["InterpMode", 0]
				]
			],
			[
				1,
				_startPos,
				[
					(vectorDir _tractor) vectorMultiply -1,
					[0,0,1] 
				],
				[
					["Time", _time_1],
					["ArriveTangent", vectorDir _tractor],
					["ArriveTangentWeight", 50],
					["InterpMode", 0]
				]
			]
		];

		private _timelineData     = [ // Timeline variables
		    ["Length", _time_1],
		    ["Loop", false],
			["InterpMode", 0],
			["EventFinished", "_this call ttt_amp_kf_fnc_parkTractor"]
		];

		private _curvesData = [
		    [ // curve1
		    	[_tractor], // vehicles
		        [ // Curve variables
		            ["OrientationMode", 0],
		            ["TimeInSeconds", true]
		        ],
		        _keysData
		    ]
		];

		private _group = [_carrier] call ttt_amp_kf_fnc_getGroup;

		_timeline = [_timelineData, _curvesData, _group] call ttt_amp_kf_fnc_keyframe;
		_timeline setVariable ["ttt_amp_carrier", _carrier];
		_timeline setVariable ["ttt_amp_plane", _plane];
		[_timeline] call BIS_fnc_timeline_play;
		_timeline

		
		// detach _cart;

	} else {
		airboss customChat [_radio, "Tractor to start position blocked"];
		airboss customChat [_radio, "Trying again in 10 seconds ..."];
		private _attempts = (_tractor getVariable ["ttt_nimitz_tractorAttemptToStart", 0]) + 1;
		
		if (_attempts == 5) then {
			airboss customChat [_radio, "Giving up driving to start position, despawning tractor on the spot"];
			deleteVehicleCrew _tractor;
			deleteVehicle _tractor;
			deleteVehicle _cart;
		} else {
			_tractor setVariable ["ttt_nimitz_tractorAttemptToStart", _attempts];
			[_carrier, _plane] spawn {
				sleep 10;
				_this call ttt_amp_kf_fnc_tractorReturn;
			};
		};
	};
	_carrier;
};

ttt_amp_kf_fnc_parkTractor = {
	params ["_timeline"];
	private _carrier = _timeline getVariable "ttt_amp_carrier";
	private _plane = _timeline getVariable "ttt_amp_plane";
	private _tractor = _plane getVariable "ttt_nimitz_tractor";
	private _cart = attachedObjects _tractor select 0;
	private _radio = _carrier getVariable "ttt_nimitz_radio";
	airboss customChat [_radio, "Tractor parked"];

	_plane setVariable ["ttt_nimitz_tractor", nil];
	_tractor setVariable ["ttt_nimitz_plane", objNull];
	_tractor animateSource ["wheel_rot_source", 0, true];
	_cart animateSource ["wheel_rot_source", 0, true];
	_tractor engineOn false;
};

ttt_amp_kf_fnc_raiseWeaponsElevator = {
	params ["_carrier", "_plane"];
	[_carrier getVariable "JDG_carrier_hangar_1", 2] spawn ttt_fnc_elevator;
	_carrier;
};

ttt_amp_kf_fnc_lowerWeaponsElevator = {
	params ["_carrier", "_plane"];
	[_carrier getVariable "JDG_carrier_hangar_1", 3] spawn ttt_fnc_elevator;
	_carrier;
};

ttt_amp_kf_fnc_getGroup = {
	params ["_carrier"];
	private _group = _carrier getVariable ["ttt_amp_kf_logicGroup", grpNull];
	if (isNull _group) then {
		_group = createGroup [sideLogic, true];
		_carrier setVariable ["ttt_amp_kf_logicGroup", _group];
	};
	_group;
};